function h=plotoneset_samp(data,count,names,pars2plot, ...
           conf2dcol,col,clevels,dotted1d,smallfs,smw,margmeth,axlims,like,nsampperbox)

% eg. pars2plot=[3,4,5,6]

if (~exist('conf2dcol')) conf2dcol='qbwr-'; end
if (~exist('col')) col='normr-.'; end
if (~exist('clevels')) clevels=[0.68 0.95]; end
if (~exist('dotted1d')) dotted1d=0.95; end
if (~exist('smallfs')) smallfs=5; end
if (~exist('smw')) smw=0.05; end
if (~exist('margmeth')) margmeth='marg'; end
if (~exist('nsampperbox')) nsampperbox=5; end
if (exist('like')) 
  if (~isempty('like')) 
    uselike=0; 
  else
    uselike=1;
  end
else
  uselike=0;
end

npars=length(pars2plot)

if ((~exist('axlims'))|(isempty(axlims))) 
  for i=1:npars
    ipar=pars2plot(i);
    axlims(i,1)=min(data(ipar,:));
    axlims(i,2)=max(data(ipar,:));
  end
end
axlims

washeld=ishold;

for ipar1=1:npars
  ix=pars2plot(ipar1)
  x=data(ix,:);
  for ipar2=1:(ipar1-1)
     iy=pars2plot(ipar2);
    y=data(iy,:);
    subplot(npars,npars,npars*(ipar1-1)+ipar2)
    if (washeld) hold on; end
    [xim,x1vals,x2vals]=samp2imw([x' y']',count,nsampperbox);
    % contour(x1vals,x2vals,xim')
    plot2dconfgeneral(x2vals,x1vals,-log(xim)',[0.68 0.95],4,100,conf2dcol);
    axlims(ipar1,:)
    axlims(ipar2,:)
    axis([axlims(ipar2,1) axlims(ipar2,2) axlims(ipar1,1) axlims(ipar1,2)])
    xlabel(names(iy,:))
    ylabel(names(ix,:))
    set(gca,'FontSize',smallfs)
    set(get(gca,'XLabel'),'FontSize',smallfs)
    set(get(gca,'YLabel'),'FontSize',smallfs)
  end
    pause(0.1)
end

if (uselike)
  level=dotted1d;
  level_tol=0.01;
  like_level=ndlikelevel(data,count,like,level,level_tol)
end

for ipar=1:npars
  i=pars2plot(ipar);
  subplot(npars,npars,npars*(ipar-1)+ipar)
  if (washeld) hold on; end
  [p x]=samp2prob1d(data(i,:),count,smw,margmeth);
  if (length(x)>1)
    xstep=x(2)-x(1);
    pnorm=p/max(p);
    if (length(col)>4)
      h(ipar)=plot(x,pnorm,col(5:length(col)));
    end
    [lower,upper]=confreg(x,p,dotted1d,100,col);
    axis([axlims(ipar,1) axlims(ipar,2) 0 1.05])
    bfp=(upper+lower)/2;
    err=(upper-lower)/2;
%    [names(i,:),'= ',num2str(bfp),' +/- ',num2str(err)]
    fprintf(1,'%s = %8.4f +/- %8.4f\n',names(i,:),bfp,err)

    % add nd limits too 
    if (uselike)
      lower=min(data(i,find(like<like_level)));
      upper=max(data(i,find(like<like_level)));
      if (length(col)>4)
        hold on
        v=axis;
        plot([lower lower],[v(3) v(4)],col(5:length(col)));
        plot([upper upper],[v(3) v(4)],col(5:length(col)));
      end
      [num2str(lower),' < ',names(i,:),' < ',num2str(upper),' nD 95\n']
      fprintf(1,'%8.4f < %s < %8.4f   nD \n',lower,names(i,:),upper)
    end

    xlabel(names(i,:))
    ylabel('Likelihood')
    set(gca,'FontSize',smallfs)
    set(get(gca,'XLabel'),'FontSize',smallfs)
    set(get(gca,'YLabel'),'FontSize',smallfs)
  end
  j=j+1;
end
