!Proposal density 
!Lots of arbitary choices to make here..
!Using the covariance matrix to give the proposal directions typcially
!significantly increases the acceptance rate and gives faster movement 
!around parameter space.

module cycler
use settings

 integer :: loopix = 0
 integer looporder(num_params)

end module cycler

subroutine GetProposal(In, Out)
  use settings
  use Random
  use ParamDef
  use CMB_Cls
  use cycler
  implicit none
  type (ParamSet) In, Out
  double precision ranmar
  integer ix, i,j,i2, paramix,indices(num_params_used)
  logical doneinc
  real wid, tmp(num_params_used)

  integer propose_num_change


   propose_num_change = int(ranmar()*3)+1     

   if(has_propose_matrix) then
      ix = params_used(int(ranmar()*num_params_used)+1)
   else
    if (mod(loopix,num_params_used*2) == 0) &
           call RandIndices(looporder, num_params_used, num_params_used)
    loopix = loopix + 1
    j = looporder(mod(loopix,num_params_used)+1)
    ix = params_used(j) 
    doneinc =.true.
   end if
 
   Out= In

  wid = 1!Gaussian1()  !to use a e^{-|x|} like proposal here

  if (ix <= num_hard) then
    
     if (has_propose_matrix) then
        do
        tmp = 0
        do paramix = 1, propose_num_change
          if (mod(loopix,num_params_used*2) == 0) then
           call RandIndices(looporder, num_params_used, num_params_used)
          end if
         loopix = loopix + 1
         j = looporder(mod(loopix,num_params_used)+1)
   
        tmp(j) =  Gaussian1()*propose_diag(j)*wid
        end do

        Out%P(params_used) = Out%P(params_used) + MATMUL(propose_matrix,tmp)
    
        if (any(Out%P(1:num_hard) /= In%P(1:num_hard)))  exit 
        Out%P = In%P
       end do
 
     else

      do
        do i=1, min(num_hard,propose_num_change)
           if (.not. doneinc) then
               if (mod(loopix,num_params_used*2) == 0) &
                  call RandIndices(looporder, num_params_used, num_params_used)
               loopix = loopix + 1
               j = looporder(mod(loopix,num_params_used)+1)
               ix = params_used(j) 
           end if
           doneinc = .false.
           Out%P(ix) = Out%P(ix) + Gaussian1()*Scales%PWidth(ix)*wid
        end do
        if (any(Out%P(1:num_hard) /= In%P(1:num_hard)))  exit
        Out%P = In%P
      end do
     
    end if

   !Re-make initial power spectrum cache

      do i=1, num_spec_cache
        wid = 1 !Gaussian1()
        do j= 1, num_initpower
           Out%Info%InitPowerCache(j,i) = Out%P(index_initpower+j-1) + &
                    Gaussian1()*Scales%PWidth(index_initpower+j-1)*wid
        end do
      end do

  elseif (ix < index_norm) then
     !Spectral indices,etc
     if (Feedback > 1) write (*,*) 'proposing change to initpower variables'
     !Just change all of them for the moment

     if (Out%Info%cache_ix <= num_spec_cache) then
        do j = 1, num_initpower
          Out%P(index_initpower+j-1) = Out%Info%InitPowerCache(j,Out%Info%cache_ix)
        end do
        In%Info%cache_ix = In%Info%cache_ix + 1
     else
        do j = 1, num_initpower
          Out%P(index_initpower+j-1) = Out%P(index_initpower+j-1) + &
                    Gaussian1()*Scales%PWidth(index_initpower+j-1)*wid
        end do

        do i=1, num_spec_cache
         wid = 1!Gaussian1()
         do j= 1, num_initpower
           Out%Info%InitPowerCache(j,i) = Out%P(index_initpower+j-1) + &
                    Gaussian1()*Scales%PWidth(index_initpower+j-1)*wid
         end do
        end do

     end if
  else 
    if (Feedback > 1) write (*,*) 'proposing change to normalizations'
    !Fast parameters
     do
        call RandIndices(indices,num_norm, min(num_norm,propose_num_change))
        do i=1, min(num_norm,propose_num_change)
           i2 = indices(i) + index_norm -1
           Out%P(i2) = Out%P(i2) + Gaussian1()*Scales%PWidth(i2)*wid
        end do
        if (any(Out%P /= In%P))  exit
     end do

   end if

end subroutine GetProposal
