!Proposal density 
!Lots of arbitary choices to make here..
!Using the covariance matrix to give the proposal directions typcially
!significantly increases the acceptance rate and gives faster movement 
!around parameter space.

!This module doesn't do any cacheing, and should be simple to modify
!as it is independent of the Cl generator.
!If you have a covariance matrix this is probably just as good.
!It has the advantage that the Cl computation can get arbitarily complicated
!without making this code a real nightmare.

module cycler
use settings

 integer :: loopix = 0
 integer looporder(num_params)

end module cycler

subroutine GetProposal(In, Out)
  use settings
  use Random
  use ParamDef
  use cycler
  implicit none
  type (ParamSet) In, Out
  double precision ranmar
  integer ix, i,j,i2, paramix,indices(num_params_used)
  logical doneinc
  real wid, tmp(num_params_used)

  integer propose_num_change


   propose_num_change = int(ranmar()*3)+1     

   if(has_propose_matrix) then
      ix = params_used(int(ranmar()*num_params_used)+1)
   else
    if (mod(loopix,num_params_used*2) == 0) &
           call RandIndices(looporder, num_params_used, num_params_used)
    loopix = loopix + 1
    j = looporder(mod(loopix,num_params_used)+1)
    ix = params_used(j) 
    doneinc =.true.
   end if
 
   Out= In

   wid = 1 !Gaussian1()  !to use a e^{-|x|} like proposal here
    
     if (has_propose_matrix) then
 
        tmp = 0
        do paramix = 1, propose_num_change
          if (mod(loopix,num_params_used*2) == 0) then
           call RandIndices(looporder, num_params_used, num_params_used)
          end if
         loopix = loopix + 1
         j = looporder(mod(loopix,num_params_used)+1)
   
        tmp(j) =  Gaussian1()*propose_diag(j)*wid
        end do

        Out%P(params_used) = Out%P(params_used) + MATMUL(propose_matrix,tmp)
  
     else

        do i=1, propose_num_change
           if (.not. doneinc) then
               if (mod(loopix,num_params_used*2) == 0) &
                  call RandIndices(looporder, num_params_used, num_params_used)
               loopix = loopix + 1
               j = looporder(mod(loopix,num_params_used)+1)
               ix = params_used(j) 
           end if
           doneinc = .false.
           Out%P(ix) = Out%P(ix) + Gaussian1()*Scales%PWidth(ix)*wid
        end do

     end if
     
end subroutine GetProposal
